<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;

$dead_letter_exchange_name = 'dead_letter_exchange';
$dead_letter_exchange_type = 'fanout';
$dead_letter_queue_name = 'dead_letter_queue';


// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();
// 声明交换机
$channel->exchange_declare($dead_letter_exchange_name, $dead_letter_exchange_type, false, true, false);
// 声明消息队列
$channel->queue_declare($dead_letter_queue_name, false, true, false, false);
// 绑定消息队列到指定交换机
$channel->queue_bind($dead_letter_queue_name, $dead_letter_exchange_name);

echo " [Dead letter consumer] Waiting for dead letter messages. To exit press CTRL+C\n";
// 消息回调（消息消费逻辑）
$callback = function ($msg) {
    echo ' [Dead letter consumer] Received ', $msg->body, "\n";
};
// 创建消费者监听指定消息队列
$channel->basic_consume($dead_letter_queue_name, '', false, true, false, false, $callback);

while ($channel->is_open()) {
    $channel->wait();
}
// 关闭资源
$channel->close();
$connection->close();
