<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Wire\AMQPTable;


$queue_name = 'normal_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();

$args = new AMQPTable();
$args->set('x-dead-letter-exchange', 'dead_letter_exchange');
$args->set('x-message-ttl', 60000);
// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false, false, $args);

echo " [Consumer(normal_queue)] Waiting for messages. To exit press CTRL+C\n";
// 消息回调（消息消费逻辑）
$callback = function ($msg) {
    echo ' [Consumer(normal_queue)] Received ', $msg->body, "\n";
    // 回复ack
    $msg->ack();
//    // 回复nack
//    $msg->nack();
//    // 拒绝消息
//    $msg->reject(false);
};

// 创建消费者监听指定消息队列
$channel->basic_consume($queue_name, '', false, false, false, false, $callback);

while ($channel->is_open()) {
    $channel->wait();
}
// 关闭资源
$channel->close();
$connection->close();
