<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;
use PhpAmqpLib\Wire\AMQPTable;

$queue_name = 'normal_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();

$args = new AMQPTable();
$args->set('x-dead-letter-exchange', 'dead_letter_exchange');
$args->set('x-message-ttl', 60000);

// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false, false, $args);
// 消息内容
$msg = new AMQPMessage('This is a new message!');
// 发送消息到指定的消息队列中
$channel->basic_publish($msg, '', $queue_name);

echo " [Producer(normal_queue)] Sent '" . $msg->body . "'\n";

$channel->close();
$connection->close();
