<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;

$queue_name = 'hello_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();
// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false);

echo " [Consumer(Hello world)] Waiting for messages. To exit press CTRL+C\n";
// 消息回调（消息消费逻辑）
$callback = function ($msg) {
    echo ' [Consumer(Hello world)] Received ', $msg->body, "\n";
};
// 创建消费者监听指定消息队列
$channel->basic_consume($queue_name, '', false, true, false, false, $callback);

while ($channel->is_open()) {
    $channel->wait();
}
// 关闭资源
$channel->close();
$connection->close();
