<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;

$exchange_name = 'fanout_exchange';
$exchange_type = 'fanout';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();
// 声明交换机
$channel->exchange_declare($exchange_name, $exchange_type, false, true, false);

for ($i = 1; $i <= 5; $i++) {
    // 消息内容
    $msg = new AMQPMessage('This is a fanout message!' . $i);
    // 发送消息到指定的交换机(fanout交换机无需设置routing_key)
    $channel->basic_publish($msg, $exchange_name, '');

    echo " [Producer(PUB/SUB)] Sent '" . $msg->body . "'\n";
}

$channel->close();
$connection->close();
