<?php
require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;

$queue_name = 'hello_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();

// 开启发布者确认
$channel->confirm_select();

// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false);

// 5个消息为一个批次
$batch_size = 5;
$outstanding_message_count = 0;

for ($i = 1; $i <= 10; $i++) {
    // 消息内容
    $msg = new AMQPMessage('Hello World!' . $i);
    // 发送消息到指定的消息队列中
    $channel->basic_publish($msg, '', $queue_name);
    // 待确认消息+1
    $outstanding_message_count++;
    if ($outstanding_message_count == $batch_size) {
        // 等待确认  超时时间 5 秒
        $channel->wait_for_pending_acks(5000);
        $outstanding_message_count = 0;
    }
    echo " [Producer(Hello world)] Sent '" . $msg->body . "'\n";
}
// 兜底确认
if ($outstanding_message_count > 0) {
    $channel->wait_for_pending_acks(5.000);
}

$channel->close();
$connection->close();
