<?php
require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;

$queue_name = 'hello_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();

// 开启发布者确认
$channel->confirm_select();

// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false);
// 消息内容
$msg = new AMQPMessage('Hello World!');

// 发送消息到指定的消息队列中
$channel->basic_publish($msg, '', $queue_name);

// 等待确认  超时时间 5 秒
$channel->wait_for_pending_acks(5000);

echo " [Producer(Hello world)] Sent 'Hello World!'\n";

$channel->close();
$connection->close();

