<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;

$exchange_name = 'exchange_name';
$exchange_type = 'direct';
$queue_name = 'route_queue2';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
    Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();
// 声明交换机
$channel->exchange_declare($exchange_name, $exchange_type, false, true, false);
// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false);

// 绑定消息队列到指定交换机并设置队列routingKey
$channel->queue_bind($queue_name, $exchange_name, 'error');

echo " [Consumer2(Routing: error)] Waiting for messages. To exit press CTRL+C\n";

// 消息回调（消息消费逻辑）
$callback = function ($msg) {
    echo ' [Consumer2(Routing: error)] Received ', $msg->body, "\n";
};
// 创建消费者监听指定消息队列
$channel->basic_consume($queue_name, '', false, true, false, false, $callback);

while ($channel->is_open()) {
    $channel->wait();
}
// 关闭资源
$channel->close();
$connection->close();
