<?php

require_once('../vendor/autoload.php');
require_once('../Constant.php');

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;

$queue_name = 'work_queue';

// 创建连接
$connection = new AMQPStreamConnection(
    Constant::HOST,
    Constant::PORT,
    Constant::USERNAME,
    Constant::PASSWORD,
    Constant::VHOST,
    false,
     Constant::LOGIN_METHOD);
// 建立通道
$channel = $connection->channel();
// 声明消息队列
$channel->queue_declare($queue_name, false, true, false, false);
for ($i = 1; $i <= 5; $i++) {
    // 消息内容
    $msg = new AMQPMessage('This is a work message!' . $i);
    // 发送消息到指定的消息队列中
    $channel->basic_publish($msg, '', $queue_name);

    echo " [Producer(Hello world)] Sent '" . $msg->body . "'\n";
}

$channel->close();
$connection->close();
